
    clear

    % Perform a simple numeric example with MRE
    objects = (0:9)';
    relations = (-4:4)';
    data = [];
    for i=1:length(relations)
        for j=1:length(objects)
            digit1 = objects(j);
            digit2 = objects(j) + relations(i);
            if digit2 >=0 && digit2 <= 9
                data = [data; digit1 relations(i) digit2];
            end
        end
    end
    
    % Hold out relations at random
    ind = randperm(size(data, 1));
    test  = ind(1:10);
    train = ind(11:end);
    
    % Run MRE on the specified relations
    [A, R, objects_A, relations] = mre_simple(data(train,:), 4);
    
    % Evaluate generalization of relations
    for i=1:length(test)
        digit1 = data(test(i), 1);
        relation = data(test(i), 2);
        [P, mle_B] = mre_generalize(digit1, relation, A, R, A, objects_A, relations, objects_A);
        disp([num2str(digit1) ' + ' num2str(relation) ' = ' num2str(mle_B)]);
    end
    